package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.ErrorEvent;
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.geom.PerspectiveProjection;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;

	public class Credits extends MovieClip
	{
		[Embed(source = "../fonts/SWCrawlTitle.ttf", fontName = "SWCrawlTitle", mimeType = "application/x-font", embedAsCFF= "false")]
		public static var fontSWCrawlTitle:Class;

		[Embed(source = "../fonts/SWCrawlBody.ttf", fontName="SWCrawlBody", mimeType = "application/x-font", embedAsCFF= "false")]
		public static var fontSWCrawlBody:Class;

		private var main:Main;
		private var tfArray:Array = new Array();
		private var nbTextareas:int;
		private var outerLayer:Sprite;
		private var innerLayer:Sprite;
		private var backgroundLoader:Loader;
		private var persp:PerspectiveProjection = new PerspectiveProjection();
		private var frameCounter:int;
		private var creditsSpeed:int;
		private var effectiveCreditsSpeed:int;
		private var creditsWaitFrames:int;
		private var xAxisRotation:int;
		private var pFov:int;
		private var textActionsThreshold:String;
		private var creditsEndAtY:int;
		private var makeTextFadeOut:Boolean;
		private var textFadesOutAtY:int;
		private var creditsEndedLineCreated:Boolean = false;
		private var beforeCreditsLogoLoader:Loader = null;
		private var beforeCreditsLogoFileName:String;
		private var beforeCreditsLogoStartingX:int;
		private var beforeCreditsLogoStartingY:int;
		private var beforeCreditsLogoStartingZ:int;
		private var beforeCreditsLogoMoveEndsAtZ:int;
		private var beforeCreditsLogoSpeed:int;
		private var isBeforeCreditsLogoOK:Boolean;
		private var makeBeforeCreditsLogoFadeOut:Boolean;
		private var beforeCreditsLogoFadesOutAtZ:int;

		public function Credits(m:Main)
		{
			main = m;
			
			if (!creditsEndedLineCreated && (main.g.dialogueControl.library.getPhrases("credits_ended").length >= 1)) {
				main.addDialogueLineType("credits_ended");
				creditsEndedLineCreated = true;
			}

			checkDictForGeneralSettings();
			doGetGeneralSettings();
			initGeneralSettings();

			outerLayer = new Sprite();
			innerLayer = new Sprite();
			innerLayer.x = 0;
			
			backgroundLoader = new Loader();
			backgroundLoader.load(new URLRequest("Mods/" + main.cacheCData + "/credits-bg.png"));

			var i:int = 1;
			var textArea:TextField;
			
			while (i <= nbTextareas) {
				textArea = createCustomTextField(i);
				tfArray.push(textArea);
				innerLayer.addChild(textArea);
				i += 1;
			}

			outerLayer.addChild(innerLayer);
			addChild(backgroundLoader);
			addChild(outerLayer);
			
			// Rotation & PerspectiveProjection Code provided by ModGuy. Thanks !
			if (xAxisRotation != 0 && pFov != 0) {
				innerLayer.rotationX = xAxisRotation;
				persp.fieldOfView = pFov;
				persp.projectionCenter = new Point(400,300);
				outerLayer.transform.perspectiveProjection = persp;
			}
			
			if (beforeCreditsLogoFileName != "noImage") {

				beforeCreditsLogoLoader = new Loader();
				beforeCreditsLogoLoader.load(new URLRequest("Mods/" + main.cacheCData + "/" + beforeCreditsLogoFileName));
				beforeCreditsLogoLoader.x = beforeCreditsLogoStartingX;
				beforeCreditsLogoLoader.y = beforeCreditsLogoStartingY;
				beforeCreditsLogoLoader.z = beforeCreditsLogoStartingZ;
				addChild(beforeCreditsLogoLoader);
				isBeforeCreditsLogoOK = false;
			}
			else { isBeforeCreditsLogoOK = true; }
		}
		
		private function createCustomTextField(tfNumber:int):TextField {
			
			var tfName:String = "textarea" + tfNumber;
			var tempTF:TextField = new TextField();
			var tmpFormat:TextFormat;
			
			checkDictForTF(tfName);
			
			tempTF.x = parseInt(main.customCreditsDict[tfName + "StartingX"]);
			
			if (tfNumber == 1) { tempTF.y = parseInt(main.customCreditsDict[tfName + "RelativeY"]); }
			else { tempTF.y = tfArray[tfNumber - 2].y + tfArray[tfNumber - 2].height + parseInt(main.customCreditsDict[tfName + "RelativeY"]); }
			
			tempTF.width = parseInt(main.customCreditsDict[tfName + "Width"]);
			tempTF.height = main.customCreditsDict[tfName + "FontSize"];
			tempTF.selectable = false;
			tempTF.antiAliasType = "advanced";
			tempTF.autoSize = TextFieldAutoSize.CENTER;
			tempTF.wordWrap = true;
			tempTF.multiline = true;
			
			tmpFormat = tempTF.getTextFormat();
			tmpFormat.font = main.customCreditsDict[tfName + "FontName"];
			if (tmpFormat.font == "SWCrawlTitle" || tmpFormat.font == "SWCrawlBody") { tempTF.embedFonts = true; } else { tempTF.embedFonts = false; }
			tmpFormat.align = main.customCreditsDict[tfName + "Align"];
			tmpFormat.color = parseInt("0x" + main.customCreditsDict[tfName + "Color"]);
			tmpFormat.size = main.customCreditsDict[tfName + "FontSize"];
			
   			tempTF.defaultTextFormat = tmpFormat;
			tempTF.htmlText = main.customCreditsDict[tfName + "Text"];
			
			return tempTF;
		}
		
		private function checkDictForTF(subDictName:String):void {

			if (main.customCreditsDict[subDictName + "StartingX"] == null) { main.customCreditsDict[subDictName + "StartingX"] = "100"; }
			if (main.customCreditsDict[subDictName + "RelativeY"] == null) { main.customCreditsDict[subDictName + "RelativeY"] = "700"; }
			if (main.customCreditsDict[subDictName + "Width"] == null) { main.customCreditsDict[subDictName + "Width"] = "500"; }
			if (main.customCreditsDict[subDictName + "Align"] == null) { main.customCreditsDict[subDictName + "Align"] = "center"; }	
			if (main.customCreditsDict[subDictName + "Color"] == null) { main.customCreditsDict[subDictName + "Color"] = "000000"; }
			if (main.customCreditsDict[subDictName + "FontName"] == null) { main.customCreditsDict[subDictName + "FontName"] = "_sans"; }
			if (main.customCreditsDict[subDictName + "FontSize"] == null) { main.customCreditsDict[subDictName + "FontSize"] = "30"; }
			if (main.customCreditsDict[subDictName + "Text"] == null) { main.customCreditsDict[subDictName + "Text"] = "Default Text"; }
		}
		
		private function checkDictForGeneralSettings():void {
			
			if (main.customCreditsDict["creditsSpeed"] == null) { main.customCreditsDict["creditsSpeed"] = "5"; }
			if (main.customCreditsDict["applyXRotation"] == null) { main.customCreditsDict["applyXRotation"] = "0"; }
			if (main.customCreditsDict["applyPerspFieldOfView"] == null) { main.customCreditsDict["applyPerspFieldOfView"] = "0"; }
			if (main.customCreditsDict["nbTextareas"] == null) { main.customCreditsDict["nbTextareas"] = "1"; }
			if (main.customCreditsDict["textActionsThreshold"] == null) { main.customCreditsDict["textActionsThreshold"] = "bottom"; }
			if (main.customCreditsDict["creditsEndAtY"] == null) { main.customCreditsDict["creditsEndAtY"] = "-100"; }
			if (main.customCreditsDict["makeTextFadeOut"] == null) { main.customCreditsDict["makeTextFadeOut"] = "0"; }
			if (main.customCreditsDict["textFadesOutAtY"] == null) { main.customCreditsDict["textFadesOutAtY"] = "0"; }
			if (main.customCreditsDict["beforeCreditsLogoFileName"] == null) { main.customCreditsDict["beforeCreditsLogoFileName"] = "noImage"; }
			if (main.customCreditsDict["beforeCreditsLogoStartingX"] == null) { main.customCreditsDict["beforeCreditsLogoStartingX"] = "250"; }
			if (main.customCreditsDict["beforeCreditsLogoStartingY"] == null) { main.customCreditsDict["beforeCreditsLogoStartingY"] = "350"; }
			if (main.customCreditsDict["beforeCreditsLogoStartingZ"] == null) { main.customCreditsDict["beforeCreditsLogoStartingZ"] = "0"; }
			if (main.customCreditsDict["beforeCreditsLogoMoveEndsAtZ"] == null) { main.customCreditsDict["beforeCreditsLogoMoveEndsAtZ"] = "0"; }
			if (main.customCreditsDict["makeBeforeCreditsLogoFadeOut"] == null) { main.customCreditsDict["makeBeforeCreditsLogoFadeOut"] = "0"; }
			if (main.customCreditsDict["beforeCreditsLogoFadesOutAtZ"] == null) { main.customCreditsDict["beforeCreditsLogoFadesOutAtZ"] = "0"; }
			if (main.customCreditsDict["beforeCreditsLogoSpeed"] == null) { main.customCreditsDict["beforeCreditsLogoSpeed"] = "0"; }
		}
		
		private function doGetGeneralSettings():void {

			creditsSpeed = parseInt(main.customCreditsDict["creditsSpeed"]);
			xAxisRotation = parseInt(main.customCreditsDict["applyXRotation"]);
			pFov = parseInt(main.customCreditsDict["applyPerspFieldOfView"]);
			nbTextareas = parseInt(main.customCreditsDict["nbTextareas"]);
			textActionsThreshold = main.customCreditsDict["textActionsThreshold"];
			creditsEndAtY = parseInt(main.customCreditsDict["creditsEndAtY"]);
			if (main.customCreditsDict["makeTextFadeOut"] == "1") { makeTextFadeOut = true; } else { makeTextFadeOut = false; }
			textFadesOutAtY = parseInt(main.customCreditsDict["textFadesOutAtY"]);
			beforeCreditsLogoFileName = main.customCreditsDict["beforeCreditsLogoFileName"];
			beforeCreditsLogoStartingX = parseInt(main.customCreditsDict["beforeCreditsLogoStartingX"]);
			beforeCreditsLogoStartingY = parseInt(main.customCreditsDict["beforeCreditsLogoStartingY"]);
			beforeCreditsLogoStartingZ = parseInt(main.customCreditsDict["beforeCreditsLogoStartingZ"]);
			beforeCreditsLogoMoveEndsAtZ = parseInt(main.customCreditsDict["beforeCreditsLogoMoveEndsAtZ"]);
			beforeCreditsLogoSpeed = parseInt(main.customCreditsDict["beforeCreditsLogoSpeed"]);
			if (main.customCreditsDict["makeBeforeCreditsLogoFadeOut"] == "1") { makeBeforeCreditsLogoFadeOut = true; } else { makeBeforeCreditsLogoFadeOut = false; }
			beforeCreditsLogoFadesOutAtZ = parseInt(main.customCreditsDict["beforeCreditsLogoFadesOutAtZ"]);
		}

		public function rollCredits(e:*):void {

			frameCounter += 1;
			
			if (!isBeforeCreditsLogoOK) {
				
				if (makeBeforeCreditsLogoFadeOut && (beforeCreditsLogoLoader.z >= beforeCreditsLogoFadesOutAtZ) && (beforeCreditsLogoLoader.alpha > 0)) {
					beforeCreditsLogoLoader.alpha -= 0.01;
				}
				
				if (((beforeCreditsLogoSpeed > 0) && (beforeCreditsLogoLoader.z <= beforeCreditsLogoMoveEndsAtZ)) || ((beforeCreditsLogoSpeed < 0) && (beforeCreditsLogoLoader.z >= beforeCreditsLogoMoveEndsAtZ))) {
					beforeCreditsLogoLoader.z += beforeCreditsLogoSpeed;
				}
				else { isBeforeCreditsLogoOK = true; }
			}
			else {
			
				if(frameCounter % creditsWaitFrames == 0) {

					if(beforeCreditsLogoLoader != null) { beforeCreditsLogoLoader.y -= effectiveCreditsSpeed; }
					var tfActionsThreshold:int;
					
					for each(var tf:TextField in tfArray) {
						
						tf.y -= effectiveCreditsSpeed;

						switch(textActionsThreshold) { 
							case "bottom":
								tfActionsThreshold = tf.y + tf.height;
								break;
							case "center":
								tfActionsThreshold = tf.y + (tf.height / 2);
								break;
							case "top":
								tfActionsThreshold = tf.y;
								break;
							default: //bottom by default
								tfActionsThreshold = tf.y + tf.height;
								break;
						}

						if (makeTextFadeOut && (tfActionsThreshold <= textFadesOutAtY) && (tf.alpha > 0)) {
							tf.alpha -= 0.01;
						}
					}
					
					if (tfActionsThreshold <= creditsEndAtY) {

						clear();
						
						if(creditsEndedLineCreated) {
							main.g.dialogueControl.buildState("credits_ended", 130);
						}
					}
				}
			}
		}
		
		private function initGeneralSettings():void {
			
			nbTextareas = Math.max(nbTextareas, 1);
			creditsSpeed = Math.min(Math.max(creditsSpeed, 1), 9);
			
			if (Math.floor(creditsSpeed / 5) == 0) {
				effectiveCreditsSpeed = 1;
				creditsWaitFrames = 6 - (creditsSpeed % 5);
			}
			else {
				effectiveCreditsSpeed = (creditsSpeed % 5) + 1;
				creditsWaitFrames = 1;
			}
		}
		
		private function clear():void {

			for each(var tf:TextField in tfArray) {
				innerLayer.removeChild(tf);
				tf = null;
			}

			outerLayer.removeChild(innerLayer);
			innerLayer = null;
			removeChild(outerLayer);
			outerLayer = null;
			backgroundLoader.unload();
			removeChild(backgroundLoader);
			backgroundLoader = null;
			
			if(beforeCreditsLogoLoader != null) {
				beforeCreditsLogoLoader.unload();
				removeChild(beforeCreditsLogoLoader);
				beforeCreditsLogoLoader = null;
			}
			
			main.removeEnterFrame(this.rollCredits);
		}
	}
}