package  
{
	import flash.utils.Dictionary;
	/**
	 * ...
	 * @author Pimgd
	 */
	public class TriggerManager 
	{
		private var g:Object;
		private var registeredTriggers:Dictionary;
		public function TriggerManager(G:Object) 
		{
			g = G;
			registeredTriggers = new Dictionary();
		}
		
		//Note to self:
		//SDT does pause, nextWord, trigger.
		//I do trigger, nextWord.
		public function trigger():Boolean {
			var triggerName:String = g.dialogueControl.words[g.dialogueControl.sayingWord].word;
			dialogueLog("Trigger found: = " + triggerName);
			triggerName = triggerName.substring(1, triggerName.length - 1);
			var triggerWithArguments:Array = triggerName.split("_");
			var result:Boolean = triggerWithArray(triggerWithArguments);
			if (result) {
				g.dialogueControl.nextWord();
			}
			return result;
		}
		
		private function triggerWithArray(triggerSplitAsArray:Array):Boolean {
			var triggerFunction:FunctionObject = null;
			if (triggerSplitAsArray.length == 0) {
				return false;
			}
			var name:String = triggerSplitAsArray[0];
			var triggerArray:Array = triggerSplitAsArray.concat();
			triggerArray.splice(0, 1);
			triggerFunction = getFunctionObjectForTrigger(name, triggerArray.length);
			if (triggerFunction == null) {
				if (triggerArray.length == 0) {
					return false;
				} else {
					triggerArray[0] = name + "_" + triggerArray[0];
					return triggerWithArray(triggerArray);
				}
			} else {
				var debugString:String = "";
				for (var i:uint = 0; i < triggerArray.length; i++) {
					if (i != 0) {
						debugString += ",";
					}
					debugString += triggerArray[i];
				}
				dialogueLog("Trigger called: " + name + " with " + triggerArray.length + " arguments (" + debugString + ")");
				triggerFunction.call(triggerArray);
				return true;
			}
		}
		
		
		
		public function registerTrigger(name:String, argumentCount:uint, callback:FunctionObject):void {
			if (!hasTrigger(name, argumentCount)) {
				var triggerArray:Array = registeredTriggers[name];
				if (triggerArray == null) {
					triggerArray = new Array();
					registeredTriggers[name] = triggerArray;
				}
				triggerArray[argumentCount] = callback;
			} else {
				throw new Error("IllegalStateException: Already have such a trigger.");
			}
		}
		
		public function hasTrigger(name:String, argumentCount:uint):Boolean {
			var hasTrigger:Boolean = registeredTriggers.hasOwnProperty(name);
			if (hasTrigger) {
				var triggerArray:Array = registeredTriggers[name];
				if (triggerArray == null) {
					triggerArray = new Array();
					registeredTriggers[name] = triggerArray;
				}
				var callbackFunction:FunctionObject = triggerArray[argumentCount];
				return (callbackFunction != null);
			} else {
				return false;
			}
		}
		
		public function getFunctionObjectForTrigger(name:String, argumentCount:uint):FunctionObject {
			var hasTrigger:Boolean = registeredTriggers.hasOwnProperty(name);
			if (hasTrigger) {
				var triggerArray:Array = registeredTriggers[name];
				if (triggerArray == null) {
					triggerArray = new Array();
					registeredTriggers[name] = triggerArray;
				}
				var callbackFunction = triggerArray[argumentCount];
				return callbackFunction;
			} else {
				return null;
			}
		}
		
		private function dialogueLog(message:String):void {
			g.dialogueControl.advancedController.outputLog(message);
		}
		
	}

}