package  
{
	import flash.utils.Dictionary;
	/**
	 * ...
	 * @author Pimgd
	 */
	public class VariableManager 
	{
		private var g:Object;
		private var registeredVariablesSet:Dictionary;
		private var registeredVariablesGet:Dictionary;
		public function VariableManager(G:Object) 
		{
			g = G;
			registeredVariablesGet = new Dictionary();
			registeredVariablesSet = new Dictionary();
		}
		
		public function registerVariableRead(name:String, callback:FunctionObject):void {
			if (!registeredVariablesGet.hasOwnProperty(name)) {
				registeredVariablesGet[name] = callback;
				dialogueLog("Variable getter for " + name + " registered.");
			}
		}
		
		public function registerVariableWrite(name:String, callback:FunctionObject):void {
			if (!registeredVariablesSet.hasOwnProperty(name)) {
				registeredVariablesSet[name] = callback;
				dialogueLog("Variable setter for " + name + " registered.");
			}
		}
		
		public function getVariableValue(name:String):* {
			if (registeredVariablesGet.hasOwnProperty(name)) {
				return registeredVariablesGet[name].call();
			}
		}
		
		public function setVariableValue(name:String, value:*):* {
			if (registeredVariablesSet.hasOwnProperty(name)) {
				return registeredVariablesSet[name].call(value);
			}
		}
		
		
		public function variableInsert(args:Array) {//No return type, might cause problems
			if (args.length != 4) {
				return;
			}
			var x:* = getVariableValue(args[1]);
			if (x != undefined) {
				return x;
			} else {
				var index:int = findIndexOfNextSplit(args[1]);
				if (index != -1) {
					return evaluateStringQuation(args[1]);
				}
			}
		}
		
		public function evaluateStringQuation(str:String):Number {
			var stringQuation:StringQuation = new StringQuation();//this really should be static
			var arr:Array = str.split(" ");
			for (var i:uint = 0, isize:uint = arr.length; i < isize; i++) {
				var variableName:String = arr[i];
				var value:String = getVariableValueViaSDT(variableName);
				if (value != "") {
					arr[i] = value;
				}
			}
			var variable:String = arr.join(" ");
			return stringQuation.equationMath(variable);
		}
		
		public function getVariableValueViaSDT(name:String):String {
			var index:int = findIndexOfNextSplit(name);
			if (index == -2) {
				return name;
			}
			if (index != -1) {
				throw new Error("Dialogue variable has operator in name - infinite loop - operator is ("+name.charAt(index)+"), full name is: "+name);
				return "";
			}
			return g.dialogueControl.advancedController.replaceValues("*"+name+"*");
		}
		
		public function setVariableValueViaSDT(name:String, value:*):void {
			var o:Object = new Object();
			o[name] = value;
			g.dialogueControl.advancedController.setValues(o);
		}
		
		public function variableWrite(variables:*) {
			var varname:* = null;
            var value:* = null;
            for (varname in variables)
            {
                //g.dialogueControl.advancedController.outputLog("Variable " + varname + " found");
				//g.dialogueControl.advancedController.outputLog("rest" + variables);
                value = variables[varname];
				var result:* = setVariableValue(varname, value);
				if (result != undefined) {
					continue;
				}
                if (value is String && !isNaN(Number(value)))
                {
                    if (!g.dialogueControl.advancedController._dialogueDataStore.hasOwnProperty(varname))
                    {
                        g.dialogueControl.advancedController._dialogueDataStore[varname] = 0;
                    }
                    if ((value as String).charAt(0) == "-")
                    {
                        g.dialogueControl.advancedController._dialogueDataStore[varname] = g.dialogueControl.advancedController._dialogueDataStore[varname] + Number(value);
                       // g.dialogueControl.advancedController.outputLog(varname + ": " + "decrement by " + Number(value) + " = " + g.dialogueControl.advancedController._dialogueDataStore[varname]);
                    }
                    else if ((value as String).charAt(0) == "+")
                    {
                        g.dialogueControl.advancedController._dialogueDataStore[varname] = g.dialogueControl.advancedController._dialogueDataStore[varname] + Number(value);
                        //g.dialogueControl.advancedController.outputLog(varname + ": " + "increment by " + Number(value) + " = " + g.dialogueControl.advancedController._dialogueDataStore[varname]);
                    }
                    continue;
                }
                //g.dialogueControl.advancedController.outputLog("Storing " + varname + " = " + value);
                g.dialogueControl.advancedController._dialogueDataStore[varname] = value;
            }
            return;
		}
		
		public function findIndexOfNextSplit(variable:String):int {
			var operators:Array = ["+", "-", "*", "%", "/", "\\", "(", ")", "==", "!=", "<=", ">=", "||", "&&", ">", "<", "="];
			if (operators.indexOf(variable) != -1) {
				return -2;//Nope, not an operator, truuuust me. Hotfix to prevent false positive errors.
			}
			
			var checkArray:Array = new Array();
			checkArray.push([variable.indexOf("+"), "+"]);
			checkArray.push([variable.indexOf("-"), "-"]);
			checkArray.push([variable.indexOf("*"), "*"]);
			checkArray.push([variable.indexOf("%"), "%"]);
			checkArray.push([variable.indexOf("/"), "/"]);
			checkArray.push([variable.indexOf("\\"), "\\"]);
			checkArray.push([variable.indexOf("("), "("]);
			checkArray.push([variable.indexOf(")"), ")"]);
			checkArray.push([variable.indexOf("=="), "=="]);
			checkArray.push([variable.indexOf("!="), "!="]);
			checkArray.push([variable.indexOf("<="), "<="]);
			checkArray.push([variable.indexOf(">="), ">="]);
			checkArray.push([variable.indexOf("||"), "||"]);
			checkArray.push([variable.indexOf("&&"), "&&"]);
			checkArray.push([variable.indexOf(">"), ">"]);//Yes, I could have skipped <= and >=, but I didn't feel like it.
			checkArray.push([variable.indexOf("<"), "<"]);
			checkArray.push([variable.indexOf("="), "="]);
			checkArray.sortOn([0], [Array.NUMERIC]);//And voila.
			for (var i:uint = 0, isize:uint = checkArray.length; i < isize; i++) {
				if (checkArray[i][0] != -1) {
					return checkArray[i][0];
				}
			}
			return -1;
		}
		
		private function dialogueLog(message:String):void {
			g.dialogueControl.advancedController.outputLog(message);
		}
		
		/*private function decremementNormalVariable(variableName:String, byValue:Number) {
			g.dialogueControl.advancedController.outputLog(variableName + ": " + "decrement by " + byValue + " = " + g.dialogueControl.advancedController._dialogueDataStore[variableName]);
		}
		
		private function decremementSpecialVariable(variableName:String, byValue:Number) {
			g.dialogueControl.advancedController.outputLog(variableName + ": " + "decrement by " + byValue + " = " + getVariableValue(variableName));
		}*/
		
	}

}